=== modified file '.bzrignore'
--- .bzrignore	2007-09-02 15:42:18 +0000
+++ .bzrignore	2008-06-28 20:24:16 +0000
@@ -10,3 +10,4 @@
 bzr-gtk.trunk-matkor.e3p
 bzr-gtk.trunk-matkor.e3s
 bzr-gtk.trunk-matkor.e3t
+credits.pickle

=== modified file 'HACKING'
--- HACKING	2007-07-15 15:05:06 +0000
+++ HACKING	2008-07-17 11:51:03 +0000
@@ -8,4 +8,8 @@
 (http://developer.gnome.org/projects/gup/hig/) should be followed where 
 possible.
 
+Several parts of bzr-gtk are currently using glade. However, we are slowly
+trying to move away from glade so please don't add new code that uses glade and
+try to remove the use of glade.
+
 Please update the NEWS file when closing bugs or adding new features.

=== modified file 'NEWS'
--- NEWS	2008-06-06 18:04:45 +0000
+++ NEWS	2008-07-01 21:56:25 +0000
@@ -4,18 +4,52 @@
 
   * Added Refresh menu option with F5 keyboard shortcut (Russ Brown)
 
+  * Show progress bars in bzr viz window (Chad Miller, Jelmer Vernooij)
+
+  * Added menu option for indexing branches if bzr-search is present.
+    (Jelmer Vernooij)
+
+  * Add "Send Merge Directive" button in bzr viz. (Jelmer Vernooij)
+
  BUG FIXES
 
   * Replace _() calls by _i18n() calls. (Vincent Ladeuil, #187283)
   
   * Fixed adding tags. (Javier Derderian, #228709)
 
+  * Fix history mode button. (Jasper Groenewegen, #144962)
+
+  * Fixed handle-patch script. (Jelmer Vernooij)
+
+  * Fix import in olive. (Jelmer Vernooij, #223935)
+
+  * Avoid use of removed smart_add. (Jelmer Vernooij, #244025, #244027)
+
+  * Remove use of upstream removed Repository.revision_parents() 
+    (Jelmer Vernooij)
+
+  * List network drives in Olive. (Kevin Light, #244308)
+
+ CHANGES
+
+  * Moved notify icon code to separate script. (Jelmer Vernooij)
+
+  * Verify testaments when showing signatures on revisions and
+    re-enable signature display. (Jelmer Vernooij)
+
+  * Show credits for bzr-gtk in the about dialog. (Jelmer Vernooij)
+
  INTERNALS
 
   * All i18n calls should now go through _i18n which must be imported from
     bzrlib.plugins.gtk. This addresses the occasional collisions with '_' used
     as an anonymous variable. (Vincent Ladeuil)
 
+  * Add test for linegraph code. (Jelmer Vernooij)
+
+  * Remove obsolete tortoisebzr tests. (Jelmer Vernooij)
+
+  * Share revision context menu and main revision menu in bzr viz. (Jelmer Vernooij)
 
 0.94.0    2008-05-04
 

=== modified file '__init__.py'
--- __init__.py	2008-06-27 16:53:56 +0000
+++ __init__.py	2008-06-27 17:10:27 +0000
@@ -15,7 +15,6 @@
 """Graphical support for Bazaar using GTK.
 
 This plugin includes:
-commit-notify     Start the graphical notifier of commits.
 gannotate         GTK+ annotate. 
 gbranch           GTK+ branching. 
 gcheckout         GTK+ checkout. 
@@ -525,77 +524,6 @@
     register_command(cmd)
 
 
-class cmd_commit_notify(GTKCommand):
-    """Run the bzr commit notifier.
-
-    This is a background program which will pop up a notification on the users
-    screen when a commit occurs.
-    """
-
-    def run(self):
-        from notify import NotifyPopupMenu
-        gtk = open_display()
-        menu = NotifyPopupMenu()
-        icon = gtk.status_icon_new_from_file(icon_path("bzr-icon-64.png"))
-        icon.connect('popup-menu', menu.display)
-
-        import cgi
-        import dbus
-        import dbus.service
-        import pynotify
-        from bzrlib.bzrdir import BzrDir
-        from bzrlib import errors
-        from bzrlib.osutils import format_date
-        from bzrlib.transport import get_transport
-        if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
-            import dbus.glib
-        BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
-        bus = dbus.SessionBus()
-
-        def catch_branch(revision_id, urls):
-            # TODO: show all the urls, or perhaps choose the 'best'.
-            url = urls[0]
-            try:
-                if isinstance(revision_id, unicode):
-                    revision_id = revision_id.encode('utf8')
-                transport = get_transport(url)
-                a_dir = BzrDir.open_from_transport(transport)
-                branch = a_dir.open_branch()
-                revno = branch.revision_id_to_revno(revision_id)
-                revision = branch.repository.get_revision(revision_id)
-                summary = 'New revision %d in %s' % (revno, url)
-                body  = 'Committer: %s\n' % revision.committer
-                body += 'Date: %s\n' % format_date(revision.timestamp,
-                    revision.timezone)
-                body += '\n'
-                body += revision.message
-                body = cgi.escape(body)
-                nw = pynotify.Notification(summary, body)
-                def start_viz(notification=None, action=None, data=None):
-                    """Start the viz program."""
-                    pp = start_viz_window(branch, revision_id)
-                    pp.show()
-                def start_branch(notification=None, action=None, data=None):
-                    """Start a Branch dialog"""
-                    from bzrlib.plugins.gtk.branch import BranchDialog
-                    bd = BranchDialog(remote_path=url)
-                    bd.run()
-                nw.add_action("inspect", "Inspect", start_viz, None)
-                nw.add_action("branch", "Branch", start_branch, None)
-                nw.set_timeout(5000)
-                nw.show()
-            except Exception, e:
-                print e
-                raise
-        bus.add_signal_receiver(catch_branch,
-                                dbus_interface=BROADCAST_INTERFACE,
-                                signal_name="Revision")
-        pynotify.init("bzr commit-notify")
-        gtk.main()
-
-register_command(cmd_commit_notify)
-
-
 class cmd_gselftest(GTKCommand):
     """Version of selftest that displays a notification at the end"""
 

=== modified file 'about.py'
--- about.py	2008-04-01 09:59:41 +0000
+++ about.py	2008-06-28 20:24:16 +0000
@@ -23,15 +23,45 @@
 import bzrlib
 import gtk
 import os
+from bzrlib.branch import Branch
+from bzrlib.errors import NotBranchError, NoRepositoryPresent
+from bzrlib.trace import mutter
+
 from bzrlib.plugins.gtk import icon_path
 
+
+def read_license():
+    license_file = os.path.join(os.path.dirname(__file__), "COPYING")
+    if os.path.exists(license_file):
+        return file(license_file).read()
+    # Fall back to just license name if we can't find the file
+    return "GPLv2 or later"
+
+
+def load_credits():
+    import pickle
+    try:
+        credits = pickle.load(file("credits.pickle"))
+    except IOError:
+        credits = None
+    return credits
+
+
 class AboutDialog(gtk.AboutDialog):
     def __init__(self):
         super(AboutDialog, self).__init__()
         self.set_name("Bazaar GTK")
         self.set_version(bzrlib.plugins.gtk.version_string)
         self.set_website("http://bazaar-vcs.org/BzrGtk")
-        self.set_license("GNU GPL v2 or later")
-        self.set_icon(gtk.gdk.pixbuf_new_from_file(icon_path("bzr-icon-64.png")))
+        self.set_license(read_license())
+        self.set_logo(gtk.gdk.pixbuf_new_from_file(icon_path("bzr-icon-64.png")))
+        credits = load_credits()
+        if credits is not None:
+            (authors, documenters, artists, translators) = credits
+            self.set_authors(authors)
+            self.set_documenters(documenters)
+            self.set_artists(artists)
+            self.set_translator_credits("\n".join(translators))
         self.connect ("response", lambda d, r: d.destroy())
 
+

=== modified file 'branchview/linegraph.py'
--- branchview/linegraph.py	2008-05-04 18:16:01 +0000
+++ branchview/linegraph.py	2008-06-30 12:39:07 +0000
@@ -11,9 +11,10 @@
 
 from bzrlib.revision import NULL_REVISION
 from bzrlib.tsort import merge_sort
+from bzrlib import ui
 
-def linegraph(repository, start_revs, maxnum, broken_line_length = None,
-              graph_data = True, mainline_only = False):
+def linegraph(graph, start_revs, maxnum=None, broken_line_length=None,
+              graph_data=True, mainline_only=False, root_progress=None):
     """Produce a directed graph of a bzr repository.
 
     Returns a tuple of (line_graph, revid_index, columns_len) where
@@ -42,26 +43,47 @@
     It's up to you how to actually draw the nodes and lines (straight,
     curved, kinked, etc.) and to pick the actual colours for each index.
     """
-    
-    graph = repository.get_graph()
+    assert isinstance(start_revs, list)
+    def update_root_progress(step_number):
+        """IFF our container received a root progress bar, then update it."""
+        if root_progress is not None:
+            root_progress.update(None, current_cnt=step_number)
+
     graph_parents = {}
     ghosts = set()
     graph_children = {}
-    for (revid, parent_revids) in graph.iter_ancestry(start_revs):
-        if parent_revids is None:
-            ghosts.add(revid)
-            continue
-        if parent_revids == (NULL_REVISION,):
-            graph_parents[revid] = ()
-        else:
-            graph_parents[revid] = parent_revids
-        for parent in parent_revids:
-            graph_children.setdefault(parent, []).append(revid)
-        graph_children.setdefault(revid, [])
-    for ghost in ghosts:
-        for ghost_child in graph_children[ghost]:
-            graph_parents[ghost_child] = [p for p in graph_parents[ghost_child]
-                                          if p not in ghosts]
+    update_root_progress(1)
+    progress_bar = ui.ui_factory.nested_progress_bar()
+    try:
+        progress_bar.update(msg="Arranging tree fragments")
+        for i, (revid, parent_revids) in enumerate(graph.iter_ancestry(start_revs)):
+            if i % 25 == 0:
+                progress_bar.tick()
+            if parent_revids is None:
+                ghosts.add(revid)
+                continue
+            if parent_revids == (NULL_REVISION,):
+                graph_parents[revid] = ()
+            else:
+                graph_parents[revid] = parent_revids
+            for parent in parent_revids:
+                graph_children.setdefault(parent, []).append(revid)
+            graph_children.setdefault(revid, [])
+    finally:
+        progress_bar.finished()
+
+    update_root_progress(2)
+    progress_bar = ui.ui_factory.nested_progress_bar()
+    try:
+        progress_bar.update(msg="Removing ghosts", total_cnt=len(ghosts))
+        for i, ghost in enumerate(ghosts):
+            if i % 25 == 0:
+                progress_bar.update(None, current_cnt=i)
+            for ghost_child in graph_children[ghost]:
+                graph_parents[ghost_child] = [p for p in graph_parents[ghost_child]
+                                              if p not in ghosts]
+    finally:
+        progress_bar.finished()
     graph_parents["top:"] = start_revs
 
     if len(graph_parents)>0:
@@ -93,36 +115,45 @@
     
     linegraph = []    
     
-    for (rev_index, (sequence_number,
-                     revid,
-                     merge_depth,
-                     revno_sequence,
-                     end_of_merge)) in enumerate(merge_sorted_revisions):
-        if maxnum and rev_index >= maxnum:
-            break
-        revid_index[revid] = rev_index
-        
-        parents = graph_parents[revid]
-        linegraph.append([revid,
-                          None,
-                          [],
-                          parents,
-                          None,
-                          revno_sequence])
-        
-        if graph_data:
-            revno_index[revno_sequence] = rev_index
-            
-            branch_id = revno_sequence[0:-1]
-            
-            branch_line = None
-            if branch_id not in branch_lines:
-                branch_line = []
-                branch_lines[branch_id] = branch_line
-            else:
-                branch_line = branch_lines[branch_id]
-            
-            branch_line.append(rev_index)        
+    update_root_progress(3)
+    progress_bar = ui.ui_factory.nested_progress_bar()
+    try:
+        progress_bar.update(msg="Finding nodes", total_cnt=len(merge_sorted_revisions))
+        for (rev_index, (sequence_number,
+                         revid,
+                         merge_depth,
+                         revno_sequence,
+                         end_of_merge)) in enumerate(merge_sorted_revisions):
+
+            if rev_index % 25 == 0:
+                progress_bar.update(None, current_cnt=rev_index)
+            if maxnum and rev_index >= maxnum:
+                break
+            revid_index[revid] = rev_index
+            
+            parents = graph_parents[revid]
+            linegraph.append([revid,
+                              None,
+                              [],
+                              parents,
+                              None,
+                              revno_sequence])
+            
+            if graph_data:
+                revno_index[revno_sequence] = rev_index
+                
+                branch_id = revno_sequence[0:-1]
+                
+                branch_line = None
+                if branch_id not in branch_lines:
+                    branch_line = []
+                    branch_lines[branch_id] = branch_line
+                else:
+                    branch_line = branch_lines[branch_id]
+                
+                branch_line.append(rev_index)        
+    finally:
+        progress_bar.finished()
 
     if graph_data:
         branch_ids = branch_lines.keys()
@@ -150,178 +181,194 @@
         columns = [list(empty_column)]
         
         
-        for branch_id in branch_ids:
-            branch_line = branch_lines[branch_id]
-            
-            # Find the col_index for the direct parent branch. This will be the
-            # starting point when looking for a free column.
-            parent_col_index = 0
-            parent_index = None
-            if len(branch_id) > 1:
-                parent_revno = branch_id[0:-1]
-                if parent_revno in revno_index:
-                    parent_index = revno_index[parent_revno]
-                    parent_node = linegraph[parent_index][1]
-                    if parent_node:
-                        parent_col_index = parent_node[0]
-                    
-            
-            col_search_order = _branch_line_col_search_order(columns,
-                                                             parent_col_index)
-            color = reduce(lambda x, y: x+y, branch_id, 0)
-            cur_cont_line = []
-            
-            line_range = []
-            last_rev_index = None
-            for rev_index in branch_line:
-                if last_rev_index:
-                    if broken_line_length and \
-                       rev_index - last_rev_index > broken_line_length:
-                        line_range.append(last_rev_index+1)
-                        line_range.append(rev_index-1)
-                    else:
-                        line_range.extend(range(last_rev_index+1, rev_index))
-                
-                line_range.append(rev_index)
-                last_rev_index = rev_index
-            
-            if parent_index:
-                if broken_line_length and \
-                   parent_index - last_rev_index > broken_line_length:
-                    line_range.append(last_rev_index+1)
-                else:
-                    line_range.extend(range(last_rev_index+1, parent_index))
-            
-            col_index = _find_free_column(columns,
-                                          empty_column,
-                                          col_search_order,
-                                          line_range)
-            node = (col_index, color)
-            for rev_index in branch_line:
-                linegraph[rev_index][1] = node
-                columns[col_index][rev_index] = True
-            
-            for rev_index in branch_line:
-                (sequence_number,
-                     revid,
-                     merge_depth,
-                     revno_sequence,
-                     end_of_merge) = merge_sorted_revisions[rev_index]
-                
-                linegraph[rev_index][4] = graph_children[revid]
-                col_index = linegraph[rev_index][1][0]
-                
-                for parent_revid in graph_parents[revid]:
-                    if parent_revid in revid_index:
-                        
-                        parent_index = revid_index[parent_revid]                            
+        update_root_progress(4)
+        progress_bar = ui.ui_factory.nested_progress_bar()
+        try:
+            progress_bar.update(msg="Organizing edges", total_cnt=len(branch_ids))
+            for i, branch_id in enumerate(branch_ids):
+                if i % 25 == 0:
+                    progress_bar.update(None, current_cnt=i)
+                branch_line = branch_lines[branch_id]
+                
+                # Find the col_index for the direct parent branch. This will be the
+                # starting point when looking for a free column.
+                parent_col_index = 0
+                parent_index = None
+                if len(branch_id) > 1:
+                    parent_revno = branch_id[0:-1]
+                    if parent_revno in revno_index:
+                        parent_index = revno_index[parent_revno]
                         parent_node = linegraph[parent_index][1]
                         if parent_node:
                             parent_col_index = parent_node[0]
+                        
+                
+                col_search_order = _branch_line_col_search_order(columns,
+                                                                 parent_col_index)
+                color = reduce(lambda x, y: x+y, branch_id, 0)
+                cur_cont_line = []
+                
+                line_range = []
+                last_rev_index = None
+                for rev_index in branch_line:
+                    if last_rev_index:
+                        if broken_line_length and \
+                           rev_index - last_rev_index > broken_line_length:
+                            line_range.append(last_rev_index+1)
+                            line_range.append(rev_index-1)
                         else:
-                            parent_col_index = None
-                        col_search_order = \
-                                _line_col_search_order(columns,
-                                                       parent_col_index,
-                                                       col_index)
-                            
-                        # If this line is really long, break it.
-                        if len(branch_id) > 0 and \
-                           broken_line_length and \
-                           parent_index - rev_index > broken_line_length:
-                            child_line_col_index = \
-                                _find_free_column(columns,
-                                                  empty_column,
-                                                  col_search_order,
-                                                  (rev_index + 1,))
-                            _mark_column_as_used(columns,
-                                                 child_line_col_index,
-                                                 (rev_index + 1,))
-                            
-                            # Recall _line_col_search_order to reset it back to
-                            # the beging.
+                            line_range.extend(range(last_rev_index+1, rev_index))
+                    
+                    line_range.append(rev_index)
+                    last_rev_index = rev_index
+                
+                if parent_index:
+                    if broken_line_length and \
+                       parent_index - last_rev_index > broken_line_length:
+                        line_range.append(last_rev_index+1)
+                    else:
+                        line_range.extend(range(last_rev_index+1, parent_index))
+                
+                col_index = _find_free_column(columns,
+                                              empty_column,
+                                              col_search_order,
+                                              line_range)
+                node = (col_index, color)
+                for rev_index in branch_line:
+                    linegraph[rev_index][1] = node
+                    columns[col_index][rev_index] = True
+                
+                for rev_index in branch_line:
+                    (sequence_number,
+                         revid,
+                         merge_depth,
+                         revno_sequence,
+                         end_of_merge) = merge_sorted_revisions[rev_index]
+                    
+                    linegraph[rev_index][4] = graph_children[revid]
+                    col_index = linegraph[rev_index][1][0]
+                    
+                    for parent_revid in graph_parents[revid]:
+                        if parent_revid in revid_index:
+                            
+                            parent_index = revid_index[parent_revid]                            
+                            parent_node = linegraph[parent_index][1]
+                            if parent_node:
+                                parent_col_index = parent_node[0]
+                            else:
+                                parent_col_index = None
                             col_search_order = \
                                     _line_col_search_order(columns,
                                                            parent_col_index,
                                                            col_index)
-                            parent_col_line_index = \
-                                _find_free_column(columns,
-                                                  empty_column,
-                                                  col_search_order,
-                                                  (parent_index - 1,))
-                            _mark_column_as_used(columns,
-                                                 parent_col_line_index,
-                                                 (parent_index - 1,))
-                            lines.append((rev_index,
-                                          parent_index,
-                                          (child_line_col_index,
-                                           parent_col_line_index)))
-                        else :
-                            line_col_index = col_index
-                            if parent_index - rev_index >1:
-                                line_range = range(rev_index + 1, parent_index)
-                                line_col_index = \
-                                    _find_free_column(columns,
-                                                      empty_column,
-                                                      col_search_order,
-                                                      line_range)
-                                _mark_column_as_used(columns,
-                                                     line_col_index,
-                                                     line_range)
-                            lines.append((rev_index,
-                                          parent_index,
-                                          (line_col_index,)))
+                                
+                            # If this line is really long, break it.
+                            if len(branch_id) > 0 and \
+                               broken_line_length and \
+                               parent_index - rev_index > broken_line_length:
+                                child_line_col_index = \
+                                    _find_free_column(columns,
+                                                      empty_column,
+                                                      col_search_order,
+                                                      (rev_index + 1,))
+                                _mark_column_as_used(columns,
+                                                     child_line_col_index,
+                                                     (rev_index + 1,))
+                                
+                                # Recall _line_col_search_order to reset it back to
+                                # the beging.
+                                col_search_order = \
+                                        _line_col_search_order(columns,
+                                                               parent_col_index,
+                                                               col_index)
+                                parent_col_line_index = \
+                                    _find_free_column(columns,
+                                                      empty_column,
+                                                      col_search_order,
+                                                      (parent_index - 1,))
+                                _mark_column_as_used(columns,
+                                                     parent_col_line_index,
+                                                     (parent_index - 1,))
+                                lines.append((rev_index,
+                                              parent_index,
+                                              (child_line_col_index,
+                                               parent_col_line_index)))
+                            else :
+                                line_col_index = col_index
+                                if parent_index - rev_index >1:
+                                    line_range = range(rev_index + 1, parent_index)
+                                    line_col_index = \
+                                        _find_free_column(columns,
+                                                          empty_column,
+                                                          col_search_order,
+                                                          line_range)
+                                    _mark_column_as_used(columns,
+                                                         line_col_index,
+                                                         line_range)
+                                lines.append((rev_index,
+                                              parent_index,
+                                              (line_col_index,)))
+        finally:
+            progress_bar.finished()
         
-        for (child_index, parent_index, line_col_indexes) in lines:
-            (child_col_index, child_color) = linegraph[child_index][1]
-            (parent_col_index, parent_color) = linegraph[parent_index][1]
-            
-            if len(line_col_indexes) == 1:
-                if parent_index - child_index == 1:
-                    linegraph[child_index][2].append(
-                        (child_col_index,
-                         parent_col_index,
-                         parent_color))
+        update_root_progress(5)
+        progress_bar = ui.ui_factory.nested_progress_bar()
+        try:
+            progress_bar.update(msg="Pretifying graph", total_cnt=len(lines))
+            for i, (child_index, parent_index, line_col_indexes) in enumerate(lines):
+                if i % 25 == 0:
+                    progress_bar.update(None, current_cnt=i)
+                (child_col_index, child_color) = linegraph[child_index][1]
+                (parent_col_index, parent_color) = linegraph[parent_index][1]
+                
+                if len(line_col_indexes) == 1:
+                    if parent_index - child_index == 1:
+                        linegraph[child_index][2].append(
+                            (child_col_index,
+                             parent_col_index,
+                             parent_color))
+                    else:
+                        # line from the child's column to the lines column
+                        linegraph[child_index][2].append(
+                            (child_col_index,
+                             line_col_indexes[0],
+                             parent_color))
+                        # lines down the line's column
+                        for line_part_index in range(child_index+1, parent_index-1):
+                            linegraph[line_part_index][2].append(
+                                (line_col_indexes[0],   
+                                 line_col_indexes[0],
+                                 parent_color))
+                        # line from the line's column to the parent's column
+                        linegraph[parent_index-1][2].append(
+                            (line_col_indexes[0],
+                             parent_col_index,
+                             parent_color))
                 else:
+                    # Broken line
                     # line from the child's column to the lines column
                     linegraph[child_index][2].append(
                         (child_col_index,
                          line_col_indexes[0],
                          parent_color))
-                    # lines down the line's column
-                    for line_part_index in range(child_index+1, parent_index-1):
-                        linegraph[line_part_index][2].append(
-                            (line_col_indexes[0],   
-                             line_col_indexes[0],
-                             parent_color))
+                    # Broken line end
+                    linegraph[child_index+1][2].append(
+                        (line_col_indexes[0],
+                         None,
+                         parent_color))
+                    
+                    # Broken line end 
+                    linegraph[parent_index-2][2].append(
+                        (None,
+                         line_col_indexes[1],
+                         parent_color))
                     # line from the line's column to the parent's column
                     linegraph[parent_index-1][2].append(
-                        (line_col_indexes[0],
+                        (line_col_indexes[1],
                          parent_col_index,
                          parent_color))
-            else:
-                # Broken line
-                # line from the child's column to the lines column
-                linegraph[child_index][2].append(
-                    (child_col_index,
-                     line_col_indexes[0],
-                     parent_color))
-                # Broken line end
-                linegraph[child_index+1][2].append(
-                    (line_col_indexes[0],
-                     None,
-                     parent_color))
-                
-                # Broken line end 
-                linegraph[parent_index-2][2].append(
-                    (None,
-                     line_col_indexes[1],
-                     parent_color))
-                # line from the line's column to the parent's column
-                linegraph[parent_index-1][2].append(
-                    (line_col_indexes[1],
-                     parent_col_index,
-                     parent_color))
+        finally:
+            progress_bar.finished()
         return (linegraph, revid_index, len(columns))
     else:
         return (linegraph, revid_index, 0)

=== modified file 'branchview/treeview.py'
--- branchview/treeview.py	2008-06-28 15:45:39 +0000
+++ branchview/treeview.py	2008-06-30 20:11:24 +0000
@@ -13,13 +13,16 @@
 import pango
 import re
 import treemodel
+from bzrlib import ui
 
 from bzrlib.plugins.gtk import _i18n
+from bzrlib.plugins.gtk.ui import GtkProgressBar, ProgressPanel
 from linegraph import linegraph, same_branch
 from graphcell import CellRendererGraph
 from treemodel import TreeModel
 from bzrlib.revision import NULL_REVISION
 
+
 class TreeView(gtk.VBox):
 
     __gproperties__ = {
@@ -82,9 +85,6 @@
     }
 
     __gsignals__ = {
-        'revisions-loaded': (gobject.SIGNAL_RUN_FIRST, 
-                             gobject.TYPE_NONE,
-                             ()),
         'revision-selected': (gobject.SIGNAL_RUN_FIRST,
                               gobject.TYPE_NONE,
                               ()),
@@ -108,9 +108,9 @@
         """
         gtk.VBox.__init__(self, spacing=0)
 
-        self.pack_start(self.construct_loading_msg(), expand=False, fill=True)
-        self.connect('revisions-loaded', 
-                lambda x: self.loading_msg_box.hide())
+        loading_msg_widget = ProgressPanel()
+        ui.ui_factory.set_nested_progress_bar_widget(loading_msg_widget.get_progress_bar)
+        self.pack_start(loading_msg_widget, expand=False, fill=True)
 
         self.scrolled_window = gtk.ScrolledWindow()
         self.scrolled_window.set_policy(gtk.POLICY_AUTOMATIC,
@@ -120,7 +120,6 @@
         self.pack_start(self.scrolled_window, expand=True, fill=True)
 
         self.scrolled_window.add(self.construct_treeview())
-        
 
         self.iter = None
         self.branch = branch
@@ -223,7 +222,6 @@
         self.emit('tag-added', tag, revid)
         
     def refresh(self):
-        self.loading_msg_box.show()
         gobject.idle_add(self.populate, self.get_revision())
 
     def update(self):
@@ -277,39 +275,44 @@
                        should be broken.
         """
 
-        if self.compact:
-            broken_line_length = 32
-        else:
-            broken_line_length = None
-        
-        show_graph = self.graph_column.get_visible()
-
-        self.branch.lock_read()
-        (linegraphdata, index, columns_len) = linegraph(self.branch.repository,
-                                                        (self.start,) , # Sequence of start revisions
-                                                        self.maxnum, 
-                                                        broken_line_length,
-                                                        show_graph,
-                                                        self.mainline_only)
-
-        self.model = TreeModel(self.branch, linegraphdata)
-        self.graph_cell.columns_len = columns_len
-        width = self.graph_cell.get_size(self.treeview)[2]
-        if width > 500:
-            width = 500
-        self.graph_column.set_fixed_width(width)
-        self.graph_column.set_max_width(width)
-        self.index = index
-        self.treeview.set_model(self.model)
-
-        if not revision or revision == NULL_REVISION:
-            self.treeview.set_cursor(0)
-        else:
-            self.set_revision(revision)
-
-        self.emit('revisions-loaded')
-
-        return False
+        self.progress_bar = ui.ui_factory.nested_progress_bar()
+        self.progress_bar.update(msg="Loading ancestry graph", total_cnt=5)
+
+        try:
+            if self.compact:
+                broken_line_length = 32
+            else:
+                broken_line_length = None
+            
+            show_graph = self.graph_column.get_visible()
+
+            self.branch.lock_read()
+            (linegraphdata, index, columns_len) = linegraph(self.branch.repository.get_graph(),
+                                                            self.start,
+                                                            self.maxnum, 
+                                                            broken_line_length,
+                                                            show_graph,
+                                                            self.mainline_only,
+                                                            self.progress_bar)
+
+            self.model = TreeModel(self.branch, linegraphdata)
+            self.graph_cell.columns_len = columns_len
+            width = self.graph_cell.get_size(self.treeview)[2]
+            if width > 500:
+                width = 500
+            self.graph_column.set_fixed_width(width)
+            self.graph_column.set_max_width(width)
+            self.index = index
+            self.treeview.set_model(self.model)
+
+            if not revision or revision == NULL_REVISION:
+                self.treeview.set_cursor(0)
+            else:
+                self.set_revision(revision)
+
+            return False
+        finally:
+            self.progress_bar.finished()
 
     def construct_treeview(self):
         self.treeview = gtk.TreeView()
@@ -394,25 +397,6 @@
         
         return self.treeview
     
-    def construct_loading_msg(self):
-        image_loading = gtk.image_new_from_stock(gtk.STOCK_REFRESH,
-                                                 gtk.ICON_SIZE_BUTTON)
-        image_loading.show()
-        
-        label_loading = gtk.Label(
-            _i18n("Please wait, loading ancestral graph..."))
-        label_loading.set_alignment(0.0, 0.5)
-        label_loading.show()
-        
-        self.loading_msg_box = gtk.HBox()
-        self.loading_msg_box.set_spacing(5)
-        self.loading_msg_box.set_border_width(5)        
-        self.loading_msg_box.pack_start(image_loading, False, False)
-        self.loading_msg_box.pack_start(label_loading, True, True)
-        self.loading_msg_box.show()
-        
-        return self.loading_msg_box
-
     def _on_selection_changed(self, treeview):
         """callback for when the treeview changes."""
         (path, focus) = treeview.get_cursor()
@@ -421,9 +405,9 @@
             self.emit('revision-selected')
 
     def _on_revision_selected(self, widget, event):
-        from bzrlib.plugins.gtk.revisionmenu import RevisionPopupMenu
+        from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
         if event.button == 3:
-            menu = RevisionPopupMenu(self.branch.repository, 
+            menu = RevisionMenu(self.branch.repository, 
                 [self.get_revision().revision_id],
                 self.branch)
             menu.connect('tag-added', lambda w, t, r: self.add_tag(t, r))

=== added file 'bzr-notify'
--- bzr-notify	1970-01-01 00:00:00 +0000
+++ bzr-notify	2008-06-27 17:10:27 +0000
@@ -0,0 +1,72 @@
+#!/usr/bin/env python
+
+"""Run the bzr tray icon.
+
+This is a background program which will pop up a notification on the users
+screen when a commit occurs.
+"""
+
+from bzrlib.plugin import load_plugins
+load_plugins()
+
+from bzrlib.plugins.gtk import open_display, icon_path
+
+from notify import NotifyPopupMenu
+gtk = open_display()
+menu = NotifyPopupMenu()
+icon = gtk.status_icon_new_from_file(icon_path("bzr-icon-64.png"))
+icon.connect('popup-menu', menu.display)
+
+import cgi
+import dbus
+import dbus.service
+import pynotify
+from bzrlib.bzrdir import BzrDir
+from bzrlib import errors
+from bzrlib.osutils import format_date
+from bzrlib.transport import get_transport
+if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
+	import dbus.glib
+BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
+bus = dbus.SessionBus()
+
+def catch_branch(revision_id, urls):
+	# TODO: show all the urls, or perhaps choose the 'best'.
+	url = urls[0]
+	try:
+		if isinstance(revision_id, unicode):
+			revision_id = revision_id.encode('utf8')
+		transport = get_transport(url)
+		a_dir = BzrDir.open_from_transport(transport)
+		branch = a_dir.open_branch()
+		revno = branch.revision_id_to_revno(revision_id)
+		revision = branch.repository.get_revision(revision_id)
+		summary = 'New revision %d in %s' % (revno, url)
+		body  = 'Committer: %s\n' % revision.committer
+		body += 'Date: %s\n' % format_date(revision.timestamp,
+			revision.timezone)
+		body += '\n'
+		body += revision.message
+		body = cgi.escape(body)
+		nw = pynotify.Notification(summary, body)
+		def start_viz(notification=None, action=None, data=None):
+			"""Start the viz program."""
+			pp = start_viz_window(branch, revision_id)
+			pp.show()
+		def start_branch(notification=None, action=None, data=None):
+			"""Start a Branch dialog"""
+			from bzrlib.plugins.gtk.branch import BranchDialog
+			bd = BranchDialog(remote_path=url)
+			bd.run()
+		nw.add_action("inspect", "Inspect", start_viz, None)
+		nw.add_action("branch", "Branch", start_branch, None)
+		nw.set_timeout(5000)
+		nw.show()
+	except Exception, e:
+		print e
+		raise
+bus.add_signal_receiver(catch_branch,
+						dbus_interface=BROADCAST_INTERFACE,
+						signal_name="Revision")
+pynotify.init("bzr-notify")
+gtk.main()

=== added file 'create-credits.py'
--- create-credits.py	1970-01-01 00:00:00 +0000
+++ create-credits.py	2008-06-28 20:24:16 +0000
@@ -0,0 +1,26 @@
+#!/usr/bin/python
+# Copyright (C) 2008 Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from bzrlib.branch import Branch
+from bzrlib.plugins.stats import find_credits
+
+import pickle
+
+branch = Branch.open(".")
+credits = find_credits(branch.repository, branch.last_revision())
+
+pickle.dump(credits, file("credits.pickle", 'w'))

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2008-06-23 08:05:19 +0000
+++ olive/__init__.py	2008-07-17 21:24:16 +0000
@@ -442,6 +442,9 @@
             # History Mode deactivated
             self.entry_history.set_sensitive(False)
             self.button_history.set_sensitive(False)
+            
+            # Return right window to normal view by acting like we jump to it
+            self.on_button_location_jump_clicked(widget)
     
     @show_bzr_error
     def on_entry_history_revno_key_press_event(self, widget, event):
@@ -734,8 +737,8 @@
 
     def on_menuitem_remove_file_activate(self, widget):
         """ Remove (unversion) selected file. """
-        from remove import OliveRemoveDialog
-        remove = OliveRemoveDialog(self.wt, self.wtpath,
+        from bzrlib.plugins.gtk.olive.remove import RemoveDialog
+        remove = RemoveDialog(self.wt, self.wtpath,
                                    selected=self.get_selected_right(),
                                    parent=self.window)
         response = remove.run()
@@ -773,7 +776,8 @@
         else:
             branch = self.remote_branch
 
-        window = branchwin.BranchWindow(branch, branch.last_revision(), None, parent=self.window)
+        window = branchwin.BranchWindow(branch, [branch.last_revision()], None, 
+                                        parent=self.window)
         window.show()
     
     def on_menuitem_view_refresh_activate(self, widget):
@@ -1485,7 +1489,8 @@
         
         driveletters = []
         for drive in string.ascii_uppercase:
-            if win32file.GetDriveType(drive+':') == win32file.DRIVE_FIXED:
+            if win32file.GetDriveType(drive+':') == win32file.DRIVE_FIXED or\
+                win32file.GetDriveType(drive+':') == win32file.DRIVE_REMOTE:
                 driveletters.append(drive+':')
         return driveletters
     

=== modified file 'olive/add.py'
--- olive/add.py	2008-05-05 18:16:46 +0000
+++ olive/add.py	2008-06-29 18:32:05 +0000
@@ -69,20 +69,16 @@
                              _i18n('Please select a file from the list,\nor choose the other option.'))
                 return
             
-            fullpath = self.wt.abspath(os.path.join(self.wtpath, filename))
-            
             try:
-                bzrlib.add.smart_add([fullpath])
+                self.wt.add([filename])
             except errors.NotBranchError:
                 error_dialog(_i18n('Directory is not a branch'),
                              _i18n('You can perform this action only in a branch.'))
                 return
         elif radio_unknown.get_active():
             # Add unknown files recursively
-            fullpath = self.wt.abspath(self.wtpath)
-            
             try:
-                bzrlib.add.smart_add([fullpath], True)
+                self.wt.add(self.wt.unknowns())
             except errors.NotBranchError:
                 error_dialog(_i18n('Directory is not a branch'),
                              _i18n('You can perform this action only in a branch.'))

=== modified file 'olive/menu.py'
--- olive/menu.py	2008-05-05 18:18:08 +0000
+++ olive/menu.py	2008-06-30 12:15:06 +0000
@@ -30,13 +30,12 @@
 import bzrlib.errors as errors
 from bzrlib.workingtree import WorkingTree
 
-from bzrlib.plugins.gtk import _i18n
+from bzrlib.plugins.gtk import _i18n, launch
 from bzrlib.plugins.gtk.dialog import error_dialog, info_dialog, question_dialog, warning_dialog
 from bzrlib.plugins.gtk.errors import show_bzr_error
 from bzrlib.plugins.gtk.annotate.gannotate import GAnnotateWindow
 from bzrlib.plugins.gtk.annotate.config import GAnnotateConfig
 from bzrlib.plugins.gtk.diff import DiffWindow
-from launch import launch
 from bzrlib.plugins.gtk.olive import Preferences
 
 class OliveMenu:
@@ -179,7 +178,8 @@
                          _i18n('Please select a file from the list,\nor choose the other option.'))
             return
         
-        bzrlib.add.smart_add([os.path.join(directory, filename)])
+        wt, path = WorkingTree.open_containing(os.path.join(directory, filename))
+        wt.add([path])
     
     @show_bzr_error
     def annotate(self, action):

=== modified file 'olive/move.py'
--- olive/move.py	2008-05-05 18:16:46 +0000
+++ olive/move.py	2008-06-28 16:59:50 +0000
@@ -31,7 +31,7 @@
 
 from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog
-from errors import show_bzr_error
+from bzrlib.plugins.gtk.errors import show_bzr_error
 from guifiles import GLADEFILENAME
 
 

=== modified file 'olive/remove.py'
--- olive/remove.py	2008-05-05 18:16:46 +0000
+++ olive/remove.py	2008-07-17 21:24:16 +0000
@@ -23,76 +23,20 @@
 	pass
 
 import gtk
-import gtk.glade
 
 import bzrlib.errors as errors
 
 from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog, warning_dialog
-from guifiles import GLADEFILENAME
-
-
-class OliveRemove:
-    """ Display the Remove file(s) dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath, selected=[]):
-        """ Initialize the Remove file(s) dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_remove')
-        
-        self.window = self.glade.get_widget('window_remove')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_remove_remove_clicked": self.remove,
-                "on_button_remove_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
-        self.wt = wt
-        self.wtpath = wtpath
-        self.selected = selected
-
-    def display(self):
-        """ Display the Remove file(s) dialog. """
-        self.window.show_all()
-        
-    @show_bzr_error
-    def remove(self, widget):
-        radio_selected = self.glade.get_widget('radiobutton_remove_selected')
-        radio_new = self.glade.get_widget('radiobutton_remove_new')
-        
-        if radio_selected.get_active():
-            # Remove only the selected file
-            filename = self.selected
-            
-            if filename is None:
-                error_dialog(_i18n('No file was selected'),
-                             _i18n('Please select a file from the list,\nor choose the other option.'))
-                return
-            
-            fullpath = self.wt.abspath(os.path.join(self.wtpath, filename))
-            
-            self.wt.remove(fullpath)
-        elif radio_new.get_active():
-            # Remove added files recursively
-            added = self.wt.changes_from(self.wt.basis_tree()).added
-            file_list = sorted([f[0] for f in added], reverse=True)
-            if len(file_list) == 0:
-                warning_dialog(_i18n('No matching files'),
-                               _i18n('No added files were found in the working tree.'))
-                return
-            self.wt.remove(file_list)
-        
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()
-
-class OliveRemoveDialog(gtk.Dialog):
+from bzrlib.plugins.gtk.errors import show_bzr_error
+
+
+class RemoveDialog(gtk.Dialog):
     """ This class wraps the old Remove window into a gtk.Dialog. """
     
-    def __init__(self, wt, wtpath, selected=[], parent=None):
+    def __init__(self, wt, wtpath, selected='', parent=None):
         """ Initialize the Remove file(s) dialog. """
-        gtk.Dialog.__init__(self, title="Remove files - Olive",
+        gtk.Dialog.__init__(self, title="Olive - Remove files",
                                   parent=parent,
                                   flags=0,
                                   buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
@@ -104,19 +48,18 @@
         
         # Create widgets
         self._label = gtk.Label(_i18n("Which file(s) do you want to remove?"))
-        self._radio_selected = gtk.RadioButton(None, _i18n("Selected only"), False)
+        self._radio_selected = gtk.RadioButton(None, _i18n("Selected: %s"%self.selected), False)
         self._radio_added = gtk.RadioButton(self._radio_selected, _i18n("All files with status 'added'"), False)
-        self._button_remove = gtk.Button(_i18n("_Remove"), use_underline=True)
+        self._button_remove = gtk.Button(stock=gtk.STOCK_REMOVE)
         
         self._button_remove.connect('clicked', self._on_remove_clicked)
         
-        self.vbox.pack_start(self._label)
-        self.vbox.pack_end(self._radio_added)
-        self.vbox.pack_end(self._radio_selected)
-        
+        self.vbox.add(self._label)
+        self.vbox.add(self._radio_selected)
+        self.vbox.add(self._radio_added)
+        self.vbox.set_spacing(3)
         self.action_area.pack_end(self._button_remove)
         
-        self.vbox.set_spacing(3)
         self.vbox.show_all()
         
     @show_bzr_error

=== modified file 'revisionmenu.py'
--- revisionmenu.py	2008-01-23 16:36:21 +0000
+++ revisionmenu.py	2008-07-01 21:54:21 +0000
@@ -27,7 +27,7 @@
 from bzrlib import (errors, ui)
 from bzrlib.revision import NULL_REVISION
 
-class RevisionPopupMenu(gtk.Menu):
+class RevisionMenu(gtk.Menu):
 
     __gsignals__ = {
             'tag-added': (
@@ -37,11 +37,18 @@
             )
     }
 
-    def __init__(self, repository, revids, branch=None, wt=None):
-        super(RevisionPopupMenu, self).__init__()
+    def __init__(self, repository, revids, branch=None, wt=None, parent=None):
+        super(RevisionMenu, self).__init__()
+        self._parent = parent
         self.branch = branch
         self.repository = repository
         self.wt = wt
+        self.set_revision_ids(revids)
+
+    def set_revision_ids(self, revids):
+        assert isinstance(revids, list)
+        for c in self.get_children():
+            self.remove(c)
         self.revids = revids
         self.create_items()
 
@@ -50,44 +57,55 @@
             item = gtk.MenuItem("View _Changes")
             item.connect('activate', self.show_diff)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Push")
             item.connect('activate', self.show_push)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Tag Revision")
             item.connect('activate', self.show_tag)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Merge Directive")
             item.connect('activate', self.store_merge_directive)
             # FIXME: self.append(item)
-            self.show_all()
+
+            item = gtk.MenuItem("_Send Merge Directive")
+            item.connect('activate', self.send_merge_directive)
+            self.append(item)
             
             if self.wt:
                 item = gtk.MenuItem("_Revert to this revision")
                 item.connect('activate', self.revert)
                 self.append(item)
-                self.show_all()
+
+        self.show_all()
 
     def store_merge_directive(self, item):
         from bzrlib.plugins.gtk.mergedirective import CreateMergeDirectiveDialog
         window = CreateMergeDirectiveDialog(self.branch, self.revids[0])
         window.show()
 
+    def send_merge_directive(self, item):
+        from bzrlib.plugins.gtk.mergedirective import SendMergeDirectiveDialog
+        from cStringIO import StringIO
+        window = SendMergeDirectiveDialog(self.branch, self.revids[0])
+        if window.run() == gtk.RESPONSE_OK:
+            outf = StringIO()
+            outf.writelines(window.get_merge_directive().to_lines())
+            mail_client = self.branch.get_config().get_mail_client()
+            mail_client.compose_merge_request(window.get_mail_to(), "[MERGE]",
+                                              outf.getvalue())
+        window.destroy()
+
     def show_diff(self, item):
         from bzrlib.plugins.gtk.diff import DiffWindow
-        window = DiffWindow(parent=self.parent)
-        parentids = self.repository.revision_parents(self.revids[0])
-
+        window = DiffWindow(parent=self._parent)
+        parentids = self.repository.get_revision(self.revids[0]).parent_ids
         if len(parentids) == 0:
             parentid = NULL_REVISION
         else:
             parentid = parentids[0]
-
         rev_tree    = self.repository.revision_tree(self.revids[0])
         parent_tree = self.repository.revision_tree(parentid)
         window.set_diff(self.revids[0], rev_tree, parent_tree)

=== modified file 'revisionview.py'
--- revisionview.py	2008-06-29 19:07:23 +0000
+++ revisionview.py	2008-06-29 19:18:34 +0000
@@ -22,9 +22,11 @@
 import gobject
 import webbrowser
 
-from bzrlib.plugins.gtk import icon_path
 from bzrlib.osutils import format_date
 from bzrlib.util.bencode import bdecode
+from bzrlib.testament import Testament
+
+from bzrlib.plugins.gtk import icon_path
 
 try:
     from bzrlib.plugins.gtk import seahorse
@@ -222,6 +224,16 @@
     def show_signature(self, crypttext):
         (cleartext, key) = seahorse.verify(crypttext)
 
+        assert cleartext is not None
+
+        inv = self.repository.get_inventory(self.revision.revision_id)
+        expected_testament = Testament(self.revision, inv).as_short_text()
+        if expected_testament != cleartext:
+            self.signature_image.set_from_file(icon_path("sign-bad.png"))
+            self.signature_label.set_markup("<b>Signature does not match repository data</b>\n" +
+                        "The signature plaintext is different from the expected testament plaintext.")
+            return
+
         if key and key.is_available():
             if key.is_trusted():
                 if key.get_display_name() == self.revision.committer:

=== added file 'search.py'
--- search.py	1970-01-01 00:00:00 +0000
+++ search.py	2008-07-01 15:28:30 +0000
@@ -0,0 +1,88 @@
+# Copyright (C) 2008 by Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+
+import gobject, gtk
+from bzrlib.plugins.search import index as _mod_index
+
+
+class SearchDialog(gtk.Dialog):
+    """Search dialog."""
+    def __init__(self, branch, parent=None):
+        gtk.Dialog.__init__(self, title="Search Revisions",
+                                  parent=parent,
+                                  flags=gtk.DIALOG_MODAL,
+                                  buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK,
+                                           gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+    
+        # Get arguments
+        self.branch = branch
+
+        self.index = _mod_index.open_index_url(branch.base)
+
+        self.searchbar = gtk.HBox()
+        self.searchentry = gtk.Entry()
+        self.searchentry.connect('activate', self._searchentry_activate)
+        # TODO: Completion using the bzr-search suggests functionality
+        self.searchbar.add(self.searchentry)
+        self.vbox.pack_start(self.searchbar, expand=False, fill=False)
+
+        self.results_model = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
+        self.results_treeview = gtk.TreeView(self.results_model)
+
+        documentname_column = gtk.TreeViewColumn("Document", gtk.CellRendererText(), text=0)
+        self.results_treeview.append_column(documentname_column)
+
+        summary_column = gtk.TreeViewColumn("Summary", gtk.CellRendererText(), text=1)
+        self.results_treeview.append_column(summary_column)
+
+        results_scrolledwindow = gtk.ScrolledWindow()
+        results_scrolledwindow.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
+        results_scrolledwindow.add(self.results_treeview)
+
+        self.vbox.pack_start(results_scrolledwindow, expand=True, fill=True)
+
+        self.set_default_size(600, 400)
+        # Show the dialog
+        self.show_all()
+
+    def get_revision(self):
+        (path, focus) = self.results_treeview.get_cursor()
+        if path is None:
+            return None
+        iter = self.results_model.get_iter(path)
+        return self.results_model.get_value(iter, 2)
+
+    def _searchentry_activate(self, entry):
+        self.results_model.clear()
+        self.index._branch.lock_read()
+        try:
+            query = [(query_item,) for query_item in self.searchentry.get_text().split(" ")]
+            for result in self.index.search(query):
+                if isinstance(result, _mod_index.FileTextHit):
+                    revid = result.text_key[-1]
+                elif isinstance(result, _mod_index.RevisionHit):
+                    revid = result.revision_key[0]
+                else:
+                    raise AssertionError()
+                self.results_model.append([result.document_name(), result.summary(), revid])
+        finally:
+            self.index._branch.unlock()

=== modified file 'setup.py'
--- setup.py	2008-06-27 16:53:56 +0000
+++ setup.py	2008-06-27 17:32:10 +0000
@@ -96,7 +96,7 @@
     maintainer_email = "jelmer@samba.org",
     description = "GTK+ Frontends for various Bazaar commands",
     license = "GNU GPL v2 or later",
-    scripts=['olive-gtk', 'bzr-handle-patch'],
+    scripts=['olive-gtk', 'bzr-handle-patch', 'bzr-notify'],
     package_dir = {
         "bzrlib.plugins.gtk": ".",
         "bzrlib.plugins.gtk.viz": "viz", 

=== modified file 'status.py'
--- status.py	2008-05-05 18:16:46 +0000
+++ status.py	2008-07-08 21:40:38 +0000
@@ -28,12 +28,13 @@
     """ Display Status window and perform the needed actions. """
     def __init__(self, wt, wtpath, revision=None):
         """ Initialize the Status window. """
-        super(StatusDialog, self).__init__(flags=gtk.DIALOG_MODAL, buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
+        super(StatusDialog, self).__init__(flags=gtk.DIALOG_MODAL, buttons=(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE))
         self.set_title("Working tree changes")
+        self.set_default_response(gtk.RESPONSE_CLOSE)
         self._create()
         self.wt = wt
         self.wtpath = wtpath
-        
+
         if revision is None:
             revision = self.wt.branch.last_revision()
             
@@ -44,13 +45,22 @@
 
     def _create(self):
         self.set_default_size(400, 300)
-        scrolledwindow = gtk.ScrolledWindow()
-        scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        self.set_has_separator(False)
+        sw = gtk.ScrolledWindow()
+        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        sw.set_shadow_type(gtk.SHADOW_IN)
         self.treeview = gtk.TreeView()
-        scrolledwindow.add(self.treeview)
-        self.vbox.pack_start(scrolledwindow, True, True)
+        sw.add(self.treeview)
+        self.vbox.pack_start(sw, True, True)
         self.vbox.show_all()
 
+        # sane border and spacing widths (as recommended by GNOME HIG) 
+        self.set_border_width(5)
+        sw.set_border_width(5)
+        self.vbox.set_spacing(2)
+        self.action_area.set_border_width(5)
+
+
     def row_diff(self, tv, path, tvc):
         file = self.model[path][1]
         if file is None:
@@ -61,6 +71,7 @@
         window.set_file(file)
         window.show()
 
+
     def _generate_status(self):
         """ Generate 'bzr status' output. """
         self.model = gtk.TreeStore(str, str)

=== modified file 'tests/__init__.py'
--- tests/__init__.py	2007-10-30 21:15:13 +0000
+++ tests/__init__.py	2008-06-29 22:44:42 +0000
@@ -27,13 +27,11 @@
     testmod_names = [
         'test_commit',
         'test_diff',
+        'test_linegraph',
         'test_preferences',
         'test_history',
         ]
 
-    if os.name == 'nt':
-        testmod_names.append("test_tortoise_bzr")
-
     result.addTest(loader.loadTestsFromModuleNames(["%s.%s" % (__name__, i) for i in testmod_names]))
     return result
 

=== added file 'tests/test_linegraph.py'
--- tests/test_linegraph.py	1970-01-01 00:00:00 +0000
+++ tests/test_linegraph.py	2008-06-29 15:54:40 +0000
@@ -0,0 +1,45 @@
+# Copyright (C) 2008 Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Test the linegraph functionality."""
+
+import os
+
+import gtk
+
+from bzrlib import (
+	graph,
+    tests,
+    )
+from bzrlib.util import bencode
+
+from bzrlib.plugins.gtk.branchview.linegraph import linegraph
+
+
+class TestLinegraph(tests.TestCase):
+	def get_graph(self, dict):
+		return graph.Graph(graph.DictParentsProvider(dict))
+
+	def test_simple(self):
+		lg = linegraph(self.get_graph({"A": ("B", "C"), "B": ()}), ["A"])
+		self.assertEquals(lg,  
+            ([
+               ['A', (0, 0), [(0, 0, 0)], ['B'], [], (2,)],
+               ['B', (0, 0), [], (), ['A'], (1,)]
+             ],
+             {'A': 0, 'B': 1},
+             1))
+

=== removed file 'tests/test_tortoise_bzr.py'
--- tests/test_tortoise_bzr.py	2007-03-15 12:43:48 +0000
+++ tests/test_tortoise_bzr.py	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-# Copyright (C) 2007 Jelmer Vernooij <jelmer@samba.org>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib import config
-
-import win32com.client as client
-
-class TestsShellExtension(TestCaseInTempDir):
-    def setUp(self):
-        super(TestsUrlHistory, self).setUp()
-        self.ext = client.Dispatch("Bazaar.ShellExtension.ContextMenu")
-
-    def test_get_command_string(self):
-        self.assertEqual(u"Hello from Python!!", self.ext.GetCommandString(1,1))

=== modified file 'ui.py'
--- ui.py	2008-06-20 03:36:30 +0000
+++ ui.py	2008-06-30 20:32:25 +0000
@@ -22,7 +22,7 @@
 import gtk
 import sys
 
-import bzrlib.progress
+from bzrlib import progress
 from bzrlib.ui import UIFactory
 
 
@@ -40,54 +40,116 @@
                          gtk.RESPONSE_NO)
 
 
-class GtkProgressBar(gtk.ProgressBar):
-    def __init__(self, stack):
-        super(GtkProgressBar, self).__init__()
+class GtkProgressBar(gtk.ProgressBar,progress._BaseProgressBar):
+    def __init__(self, _stack=None):
+        gtk.ProgressBar.__init__(self)
         self.set_fraction(0.0)
-        self._stack = stack
-
-    def finished(self):
-        self._stack.remove(self)
+        progress._BaseProgressBar.__init__(self, _stack=_stack)
+        self.current = None
+        self.total = None
 
     def clear(self):
-        pass
+        self.hide()
 
     def tick(self):
         self.pulse()
 
-    def update(self, msg=None, current=None, total=None):
+    def child_update(self, message, current, total):
+        pass
+
+    def update(self, msg=None, current_cnt=None, total_cnt=None):
+        if current_cnt:
+            self.current = current_cnt
+        if total_cnt:
+            self.total = total_cnt
         if msg is not None:
             self.set_text(msg)
-        if None not in (current, total) and total > 0:
-            self.set_fraction(1.0 * current / total)
+        if None not in (self.current, self.total):
+            self.fraction = float(self.current) / self.total
+            self.set_fraction(self.fraction)
         while gtk.events_pending():
             gtk.main_iteration()
 
 
-class GtkProgressBarStack(gtk.Window):
-    def __init__(self):
-        super(GtkProgressBarStack, self).__init__(type=gtk.WINDOW_TOPLEVEL)
+class ProgressBarWindow(gtk.Window):
+    def __init__(self, to_file=None, show_pct=None, show_spinner=None, show_eta=None, 
+                 show_bar=None, show_count=None, to_messages_file=None, _stack=None):
+        super(ProgressBarWindow, self).__init__(type=gtk.WINDOW_TOPLEVEL)
+        self._stack = _stack
         self.set_border_width(0)
         self.set_title("Progress")
         self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
-        self.vbox = gtk.VBox()
-        self.add(self.vbox)
+        self.pb = GtkProgressBar(self)
+        self.add(self.pb)
+        self.resize(250, 15)
         self.set_resizable(False)
-
-    def _adapt_size(self):
-        self.resize(250, 15 * len(self.vbox.get_children()))
-
-    def get_nested(self):
-        nested = GtkProgressBar(self)
-        self.vbox.pack_start(nested)
-        self._adapt_size()
-        self.show_all()
-        return nested
-
-    def remove(self, pb):
-        self.vbox.remove(pb)
-        if len(self.vbox.get_children()) == 0: # If there is nothing to show, don't leave a ghost window here
-             self.destroy()
+        self.show_all()
+
+    def return_pb(self, pb):
+        self._stack.return_pb(self)
+    
+    def update(self, *args, **kwargs):
+        self.pb.update(*args, **kwargs)
+
+    def finished(self):
+        self.pb.finished()
+        self.hide_all()
+ 
+    def clear(self):
+        self.pb.clear()
+        self.destroy()
+
+    def child_progress(self, *args, **kwargs):
+        return self.pb.child_progress(*args, **kwargs)
+
+    def child_update(self, *args, **kwargs):
+        return self.pb.child_update(*args, **kwargs)
+
+    def get_progress_bar(self):
+        self.show_all()
+        return self
+
+
+class ProgressPanel(gtk.HBox):
+    def __init__(self):
+        super(ProgressPanel, self).__init__()
+        image_loading = gtk.image_new_from_stock(gtk.STOCK_REFRESH,
+                                                 gtk.ICON_SIZE_BUTTON)
+        image_loading.show()
+        
+        self.pb = GtkProgressBar(self)
+        self.set_spacing(5)
+        self.set_border_width(5)        
+        self.pack_start(image_loading, False, False)
+        self.pack_start(self.pb, True, True)
+
+    def return_pb(self, pb):
+        self._stack.return_pb(self)
+
+    def get_progress_bar(self, to_file=None, show_pct=None, show_spinner=None, show_eta=None, 
+                         show_bar=None, show_count=None, to_messages_file=None, 
+                         _stack=None):
+        self._stack = _stack
+        self.show_all()
+        return self
+    
+    def update(self, *args, **kwargs):
+        self.pb.update(*args, **kwargs)
+
+    def finished(self):
+        self.pb.finished()
+        self.hide_all()
+
+    def clear(self):
+        self.pb.clear()
+        self.hide_all()
+
+    def child_progress(self, *args, **kwargs):
+        return self.pb.child_progress(*args, **kwargs)
+
+    def child_update(self, *args, **kwargs):
+        return self.pb.child_update(*args, **kwargs)
+
 
 
 class PasswordDialog(gtk.Dialog):
@@ -122,7 +184,7 @@
 
         """
         super(GtkUIFactory, self).__init__()
-        self._progress_bar_stack = None
+        self.set_nested_progress_bar_widget(ProgressBarWindow)
 
     def get_boolean(self, prompt):
         """GtkDialog with yes/no answers"""
@@ -150,11 +212,12 @@
         else:
             return None
 
+    def set_nested_progress_bar_widget(self, widget):
+        self._progress_bar_stack = progress.ProgressBarStack(klass=widget)
+
     def nested_progress_bar(self):
         """Return a nested progress bar.
         """
-        if self._progress_bar_stack is None:
-            self._progress_bar_stack = GtkProgressBarStack()
         return self._progress_bar_stack.get_nested()
 
     def set_progress_bar_vbox(self, vbox):

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2008-06-06 17:46:26 +0000
+++ viz/branchwin.py	2008-07-01 21:54:21 +0000
@@ -13,14 +13,16 @@
 import gobject
 import pango
 
-from bzrlib.plugins.gtk.window import Window
 from bzrlib.plugins.gtk import icon_path
+from bzrlib.plugins.gtk.branchview import TreeView, treemodel
 from bzrlib.plugins.gtk.tags import AddTagDialog
 from bzrlib.plugins.gtk.preferences import PreferencesWindow
-from bzrlib.plugins.gtk.branchview import TreeView, treemodel
+from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
+from bzrlib.plugins.gtk.window import Window
+
+from bzrlib.config import BranchConfig, GlobalConfig
 from bzrlib.revision import Revision, NULL_REVISION
-from bzrlib.config import BranchConfig
-from bzrlib.config import GlobalConfig
+from bzrlib.trace import mutter
 
 class BranchWindow(Window):
     """Branch window.
@@ -202,24 +204,9 @@
         go_menu.add(gtk.SeparatorMenuItem())
         go_menu.add(self.go_menu_tags)
 
-        revision_menu = gtk.Menu()
+        self.revision_menu = RevisionMenu(self.branch.repository, [], self.branch, parent=self)
         revision_menuitem = gtk.MenuItem("_Revision")
-        revision_menuitem.set_submenu(revision_menu)
-
-        revision_menu_diff = gtk.MenuItem("View Changes")
-        revision_menu_diff.connect('activate', 
-                self._menu_diff_cb)
-        
-        revision_menu_compare = gtk.MenuItem("Compare with...")
-        revision_menu_compare.connect('activate',
-                self._compare_with_cb)
-
-        revision_menu_tag = gtk.MenuItem("Tag Revision")
-        revision_menu_tag.connect('activate', self._tag_revision_cb)
-
-        revision_menu.add(revision_menu_tag)
-        revision_menu.add(revision_menu_diff)
-        revision_menu.add(revision_menu_compare)
+        revision_menuitem.set_submenu(self.revision_menu)
 
         branch_menu = gtk.Menu()
         branch_menuitem = gtk.MenuItem("_Branch")
@@ -228,6 +215,21 @@
         branch_menu.add(gtk.MenuItem("Pu_ll Revisions"))
         branch_menu.add(gtk.MenuItem("Pu_sh Revisions"))
 
+        try:
+            from bzrlib.plugins import search
+        except ImportError:
+            mutter("Didn't find search plugin")
+        else:
+            branch_menu.add(gtk.SeparatorMenuItem())
+
+            branch_index_menuitem = gtk.MenuItem("_Index")
+            branch_index_menuitem.connect('activate', self._branch_index_cb)
+            branch_menu.add(branch_index_menuitem)
+
+            branch_search_menuitem = gtk.MenuItem("_Search")
+            branch_search_menuitem.connect('activate', self._branch_search_cb)
+            branch_menu.add(branch_search_menuitem)
+
         help_menu = gtk.Menu()
         help_menuitem = gtk.MenuItem("_Help")
         help_menuitem.set_submenu(help_menu)
@@ -319,6 +321,8 @@
         parents  = self.treeview.get_parents()
         children = self.treeview.get_children()
 
+        self.revision_menu.set_revision_ids([revision.revision_id])
+
         if revision and revision != NULL_REVISION:
             prev_menu = gtk.Menu()
             if len(parents) > 0:
@@ -378,19 +382,6 @@
         self.show_diff(revision.revision_id, parent_id)
         self.treeview.grab_focus()
         
-    def _menu_diff_cb(self,w):
-        (path, focus) = self.treeview.treeview.get_cursor()
-        revid = self.treeview.model[path][treemodel.REVID]
-        
-        parentids = self.branch.repository.revision_parents(revid)
-
-        if len(parentids) == 0:
-            parentid = NULL_REVISION
-        else:
-            parentid = parentids[0]
-        
-        self.show_diff(revid,parentid)    
-
     def _back_clicked_cb(self, *args):
         """Callback for when the back button is clicked."""
         self.treeview.back()
@@ -409,22 +400,6 @@
         self.show_diff(revid, parentid)
         self.treeview.grab_focus()
 
-    def _compare_with_cb(self,w):
-        """Callback for revision 'compare with' menu. Will show a small
-            dialog with branch revisions to compare with selected revision in TreeView"""
-        
-        from bzrlib.plugins.gtk.revbrowser import RevisionBrowser
-        
-        rb = RevisionBrowser(self.branch,self)
-        ret = rb.run()
-        
-        if ret == gtk.RESPONSE_OK:          
-            (path, focus) = self.treeview.treeview.get_cursor()
-            revid = self.treeview.model[path][treemodel.REVID]
-            self.show_diff(revid, rb.selected_revid)
-            
-        rb.destroy()
-            
     def _set_revision_cb(self, w, revision_id):
         self.treeview.set_revision_id(revision_id)
 
@@ -440,21 +415,18 @@
         self.treeview.set_property('compact', self.compact_view)
         self.treeview.refresh()
 
-    def _tag_revision_cb(self, w):
-        try:
-            self.treeview.set_sensitive(False)
-            dialog = AddTagDialog(self.branch.repository, self.treeview.get_revision().revision_id, self.branch)
-            response = dialog.run()
-            if response != gtk.RESPONSE_NONE:
-                dialog.hide()
-            
-                if response == gtk.RESPONSE_OK:
-                    self.treeview.add_tag(dialog.tagname, dialog._revid)
-                
-                dialog.destroy()
-
-        finally:
-            self.treeview.set_sensitive(True)
+    def _branch_index_cb(self, w):
+        from bzrlib.plugins.search import index as _mod_index
+        _mod_index.index_url(self.branch.base)
+
+    def _branch_search_cb(self, w):
+        from bzrlib.plugins.gtk.search import SearchDialog
+        dialog = SearchDialog(self.branch)
+        
+        if dialog.run() == gtk.RESPONSE_OK:
+            self.set_revision(dialog.get_revision())
+
+        dialog.destroy()
 
     def _about_dialog_cb(self, w):
         from bzrlib.plugins.gtk.about import AboutDialog

